/*  Routines for mp integer <--> decimal conversion.	*/
/*  Also some other conversions				*/
/*  Source:  midec.c		Header:  midec.h	*/
/*  Uses some routines in miarith.c			*/
/*  Ernest Sibert -- June, 1995			*/

/*copied the following 2 procedures from sibert/multip/midec.c (updated)*/

#include <stdio.h>
#include <stdlib.h>
#include "multip.h"
#include "miarith.h"

/* ******************************************************************** */
/* ========================================================================= */

/* Convert integer to mp-integer:  d[0..P] := i, requires P >= 2	*/
/* Overflow is impossible.						*/

/* This code has been modified to convert a || int to a mp || int.  */
/* IN PROCESS */

void pint2pmi(int:current d[], int P, int:current i)
 { int:current fill = 0; int j;
   d[P] = i&Bwrd;  d[P-1] = (i&Bcy) >> Mword;  d[0] = 0;
   where ( i < 0 )
    { fill = Bwrd;  d[P-1] |= (Bwrd & (~1)); d[0] = Bneg|1; }
   for ( j = 1;  j < P-1;  j++ ) d[j] = fill;
   where ( i ) d[0] |= Nonzr;	/* Finish status */
 }

/* ========================================================================= */

/* Convert mp-integer to higher precision:		*/
/*		d[0..M] := x[0..N],  where 1<= N <= M	*/
/* Yields overflowed result if M < N .			*/

/* This code has been modified to convert a || mp-int to a higher precision
   || mp-int    **** IN PROCESS *****                              */ 

void pimup(int:current d[], int:current x[], int M, int N)
 { int:current fill=0; int i, j;
   where ( x[0] < 0 ) fill = Bwrd;
   d[0] = x[0];
   if ( M >= N )
    { for ( i = 1;  i <= M - N; i++ )   d[i] = fill;
      for ( j = 1;  i <= M;  j++, i++ ) d[i] = x[j];
    }
    else d[0] |= Ovflw;
 }

/* ========================================================================= */

/* function to convert sequential multip. prec. to parallel multi. prec. */

void mp2pmp (int:current d[], int x[], int N)
 { int i;
   for (i = 0; i <= N; i++) d[i] = x[i];
 }

/* ========================================================================= */

/* function to convert parallel multip. prec. to multiple precision   */

void pmp2mp (int d[], int:current x[], int N, int m)
 { int i;
   for (i = 0; i <=N; i++) d[i] = [m]x[i]; 
 }
